.\" $XConsortium: x11pcomp.man /main/7 1995/12/15 14:01:46 gildea $
.\" Copyright (c) 1993, 1994  X Consortium
.\" 
.\" Permission is hereby granted, free of charge, to any person obtaining
.\" a copy of this software and associated documentation files (the
.\" "Software"), to deal in the Software without restriction, including
.\" without limitation the rights to use, copy, modify, merge, publish,
.\" distribute, sublicense, and/or sell copies of the Software, and to
.\" permit persons to whom the Software is furnished to do so, subject to
.\" the following conditions:
.\" 
.\" The above copyright notice and this permission notice shall be included
.\" in all copies or substantial portions of the Software.
.\" 
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
.\" OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
.\" IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
.\" OTHER DEALINGS IN THE SOFTWARE.
.\" 
.\" Except as contained in this notice, the name of the X Consortium shall
.\" not be used in advertising or otherwise to promote the sale, use or
.\" other dealings in this Software without prior written authorization
.\" from the X Consortium.
.TH X11PERFCOMP 1 "Release 6.1" "X Version 11"
.SH NAME
x11perfcomp \- X11 server performance comparison program
.SH SYNTAX
.B x11perfcomp
[ \-r | \-ro ] [ \-l label_file ] files
.SH DESCRIPTION
The
.I x11perfcomp
program merges the output of several
.I x11perf(1)
runs into a nice tabular
format.  It takes the results in each file, fills in any missing test results if
necessary, and for each test shows the objects/second rate of each server.
If invoked with the -r or -ro options, it shows the relative performance 
of each server to the first server.
.PP
Normally,
.I x11perfcomp
uses the first file specified to determine which specific tests it should
report on.  Some (non-DEC :) servers may fail to perform
all tests.  In this case,
.I x11perfcomp
automatically substitutes in a rate of 0.0 objects/second. 
Since the first file
determines which tests to report on, this file must contain a superset of
the tests reported in the other files, else 
.I x11perfcomp
will fail.
.PP
You can provide an explicit list of tests to report on
by using the -l switch to specify a file of labels.  You can create a label
file by using the -label option in 
.I x11perf.
.SH OPTIONS
.I x11perfcomp
accepts the options listed below:
.TP 16
.B \-r
Specifies that the output should also include relative server
performance.
.TP 16
.B \-ro
Specifies that the output should include only relative server performance.
.TP 16
.B \-l label_file
Specifies a label file to use.
.SH X DEFAULTS
There are no X defaults used by this program.
.SH "SEE ALSO"
X(1), x11perf(1)
.SH AUTHORS
Mark Moraes wrote the original scripts to compare servers.
.br
Joel McCormack just munged them together a bit.
