.\" $XConsortium: xlsatoms.man /main/11 1995/12/15 14:04:33 gildea $
.\" Copyright (c) 1989, 1994  X Consortium
.\" 
.\" Permission is hereby granted, free of charge, to any person obtaining
.\" a copy of this software and associated documentation files (the
.\" "Software"), to deal in the Software without restriction, including
.\" without limitation the rights to use, copy, modify, merge, publish,
.\" distribute, sublicense, and/or sell copies of the Software, and to
.\" permit persons to whom the Software is furnished to do so, subject to
.\" the following conditions:
.\" 
.\" The above copyright notice and this permission notice shall be included
.\" in all copies or substantial portions of the Software.
.\" 
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS
.\" OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
.\" MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.
.\" IN NO EVENT SHALL THE X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR
.\" OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE,
.\" ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
.\" OTHER DEALINGS IN THE SOFTWARE.
.\" 
.\" Except as contained in this notice, the name of the X Consortium shall
.\" not be used in advertising or otherwise to promote the sale, use or
.\" other dealings in this Software without prior written authorization
.\" from the X Consortium.
.TH XLSATOMS 1 "Release 6.1" "X Version 11"
.SH NAME
xlsatoms - list interned atoms defined on server
.SH SYNOPSIS
.B xlsatoms
[-options ...]
.SH DESCRIPTION
.I Xlsatoms
lists the interned atoms.  By default, all atoms starting from 1 (the lowest
atom value defined by the protocol) are listed until unknown atom is found.
If an explicit range is given, \fIxlsatoms\fP will try all atoms in the range,
regardless of whether or not any are undefined.
.SH "OPTIONS"
.PP
.TP 8
.B \-display \fIdpy\fP
This option specifies the X server to which to connect.
.TP 8
.B \-format \fIstring\fP
This option specifies a \fIprintf\fP-style string used to list each atom
\fI<value,name>\fP pair, printed in that order (\fIvalue\fP is an \fIunsigned
long\fP and \fIname\fP is a \fIchar *\fP).  \fIXlsatoms\fP will supply a
newline at the end of each line.  The default is \fI%ld\\t%s\fP.
.TP 8
.B \-range \fI[low]-[high]\fP
This option specifies the range of atom values to check.  If \fIlow\fP is not
given, a value of 1 assumed.  If \fIhigh\fP is not given, \fIxlsatoms\fP will
stop at the first undefined atom at or above \fIlow\fP.
.TP 8
.B \-name \fIstring\fP
This option specifies the name of an atom to list.  If the atom does not 
exist, a message will be printed on the standard error.
.PP
.SH "SEE ALSO"
X(1), Xserver(1), xprop(1)
.SH ENVIRONMENT
.TP 8
.B DISPLAY
to get the default host and display to use.
.SH AUTHOR
Jim Fulton, MIT X Consortium
