/*
 
Copyright (c) 1990, 1991  X Consortium

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT.  IN NO EVENT SHALL THE
X CONSORTIUM BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN
AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN
CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

Except as contained in this notice, the name of the X Consortium shall not be
used in advertising or otherwise to promote the sale, use or other dealings
in this Software without prior written authorization from the X Consortium.

 *
 * Copyright 1990, 1991 by UniSoft Group Limited.
 * 
 * Permission to use, copy, modify, distribute, and sell this software and
 * its documentation for any purpose is hereby granted without fee,
 * provided that the above copyright notice appear in all copies and that
 * both that copyright notice and this permission notice appear in
 * supporting documentation, and that the name of UniSoft not be
 * used in advertising or publicity pertaining to distribution of the
 * software without specific, written prior permission.  UniSoft
 * makes no representations about the suitability of this software for any
 * purpose.  It is provided "as is" without express or implied warranty.
 *
 * $XConsortium: clntmssg.m,v 1.8 94/04/17 21:07:17 rws Exp $
 */
>>TITLE ClientMessage CH08
>>ASSERTION Good A
There are no assertions in sections 8.1-8.4 for xname events.
Delivery of xname events is covered by the first test for 
.F XSendEvent .
>>STRATEGY
Put out a message explaining that there are no specific assertions for
xname events in sections 8.1-8.4, and that delivery of xname events is
covered by the first test for XSendEvent.
>>CODE

	report("There are no specific assertions for %s events in sections 8.1-8.4.", TestName);
	report("Delivery of %s events is covered by the first test for XSendEvent.", TestName);
	tet_result(TET_NOTINUSE);

>>#NOTEm >>ASSERTION
>>#NOTEm When the
>>#NOTEm .M format
>>#NOTEm field of ARTICLE xname event is not one of 8, 16, or 32,
>>#NOTEm then a
>>#NOTEm .S BadValue
>>#NOTEm error occurs.
>>#NOTEd >>ASSERTION
>>#NOTEd >>#NOTE
>>#NOTEd >>#NOTE Untestable?
>>#NOTEd >>#NOTE
>>#NOTEd The server generates xname events only when a client calls
>>#NOTEd .F XSendEvent .
>>#NOTEs >>ASSERTION
>>#NOTEs When ARTICLE xname event is delivered,
>>#NOTEs then
>>#NOTEs .M type
>>#NOTEs is set to
>>#NOTEs xname.
>>#NOTEs >>ASSERTION
>>#NOTEs >>#NOTE The method of expansion is not clear.
>>#NOTEs When ARTICLE xname event is delivered,
>>#NOTEs then
>>#NOTEs .M serial
>>#NOTEs is set
>>#NOTEs from the serial number reported in the protocol
>>#NOTEs but expanded from the 16-bit least-significant bits
>>#NOTEs to a full 32-bit value.
>>#NOTEm >>ASSERTION
>>#NOTEm When ARTICLE xname event is delivered
>>#NOTEm and the event came from a
>>#NOTEm .S SendEvent
>>#NOTEm protocol request,
>>#NOTEm then
>>#NOTEm .M send_event
>>#NOTEm is set to
>>#NOTEm .S True .
>>#NOTEs >>ASSERTION
>>#NOTEs When ARTICLE xname event is delivered
>>#NOTEs and the event was not generated by a
>>#NOTEs .S SendEvent
>>#NOTEs protocol request,
>>#NOTEs then
>>#NOTEs .M send_event
>>#NOTEs is set to
>>#NOTEs .S False .
>>#NOTEm >>ASSERTION
>>#NOTEm >>#NOTE
>>#NOTEm >>#NOTE Looks like a pretty easy test (sizeof(...)).
>>#NOTEm >>#NOTE
>>#NOTEm The size of the
>>#NOTEm .M b
>>#NOTEm member of the
>>#NOTEm .M data
>>#NOTEm union is 20 bytes.
>>#NOTEm >>ASSERTION
>>#NOTEm >>#NOTE
>>#NOTEm >>#NOTE Looks like a pretty easy test (sizeof(...)).
>>#NOTEm >>#NOTE
>>#NOTEm The size of the
>>#NOTEm .M s
>>#NOTEm member of the
>>#NOTEm .M data
>>#NOTEm union is 20 bytes.
>>#NOTEm >>ASSERTION
>>#NOTEm >>#NOTE
>>#NOTEm >>#NOTE Looks like a pretty easy test (sizeof(...)).
>>#NOTEm >>#NOTE
>>#NOTEm The size of the
>>#NOTEm .M l
>>#NOTEm member of the
>>#NOTEm .M data
>>#NOTEm union is 20 bytes.
